SystemOrganization addCategory: 'OrbeonBizagiReader2'!

Object subclass: #XPDLItemImportReport
	instanceVariableNames: 'type title description solution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLItemImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 12/29/2014 05:10'!
description

   "Return the value of the instance variable 'description'."
   ^description! !

!XPDLItemImportReport methodsFor: 'Updating' stamp: 'BrunoBB 12/29/2014 05:10'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue! !

!XPDLItemImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 10/10/2015 13:52'!
solution
	^solution! !

!XPDLItemImportReport methodsFor: 'Updating' stamp: 'BrunoBB 10/10/2015 13:52'!
solution: newValue
	solution := newValue! !

!XPDLItemImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 12/29/2014 05:13'!
title

   "Return the value of the instance variable 'title'."
   ^title! !

!XPDLItemImportReport methodsFor: 'Updating' stamp: 'BrunoBB 12/29/2014 05:13'!
title: newValue

   "Modify the value of the instance variable 'title'."
   title := newValue! !

!XPDLItemImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 12/29/2014 05:10'!
type

   "Return the value of the instance variable 'type'."
   ^type! !

!XPDLItemImportReport methodsFor: 'Updating' stamp: 'BrunoBB 12/29/2014 05:10'!
type: newValue

   "Modify the value of the instance variable 'type'."
   type := newValue! !

Object subclass: #XPDLObject2
	instanceVariableNames: 'xmlSegment attributes extendedAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLObject2 subclass: #XPDLActivityNode
	instanceVariableNames: 'inTransitions outTransitions loopType loopCondition performers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 12/31/2015 08:29'!
addPerformer: aXPDLParticipantNode

	^performers add: aXPDLParticipantNode! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 06/22/2016 11:48'!
getArtifactFrom: aBpmProcessDefinition

	^self subclassResponsibility! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:22'!
hasMixedStartConditions
	"Answer whether or not the receiver has mixed start conditions.
	Some out Transitions has start condition and some Transitions has NO start condition"

	^(outTransitions anySatisfy: [:each | each startCondition notNil])
		and:[outTransitions anySatisfy: [:each | each startCondition isNil]]! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 01/20/2016 11:52'!
hasNoInOrOutTransitions

	^inTransitions isEmpty and:[outTransitions isEmpty]! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 12/30/2015 14:37'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.

	performers := OrderedCollection new.! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 12/30/2015 14:32'!
inTransitions
	^inTransitions! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 12/30/2015 14:32'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 01/20/2016 11:31'!
isActivityNode

	^true! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 12/30/2015 14:32'!
isMultiInstance

	^loopType = 'MultiInstance'! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 12/30/2015 14:32'!
loopCondition
	^loopCondition! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 12/30/2015 14:32'!
loopCondition: newValue
	loopCondition := newValue! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 12/30/2015 14:32'!
loopType
	^loopType! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 12/30/2015 14:32'!
loopType: newValue
	loopType := newValue! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 12/30/2015 14:32'!
outTransitions
	^outTransitions! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 12/30/2015 14:32'!
outTransitions: newValue
	outTransitions := newValue! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 12/30/2015 14:37'!
performers
	^performers! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 12/30/2015 14:37'!
performers: newValue
	performers := newValue! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 12/30/2015 14:32'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[',self getName, ']'.! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 12/30/2015 14:32'!
setLoopCondtionWithNode: xmlNode

	(loopType = 'None') ifTrue: [^self].

	(loopType = 'Standard') ifTrue: [^self setStandardLoopConditionWith: xmlNode].

	(loopType = 'MultiInstance') ifTrue: [^self setMultiInstanceLoopConditionWith: xmlNode].! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 12/30/2015 14:32'!
setLoopTypeWithNode: xmlNode
	"The receiver set it's loop type from the xml node <xmlNode>
	Loop type: (none) (standart) (multi-instance)"
	| loopNode |

	loopNode := xmlNode findElementNamed: 'Loop'.
	loopNode ifNil: [^self].

	self startQuantity: ([Number fromString: (xmlNode attributeAt: 'StartQuantity')] on: Error do: [:ex | nil]);
		completionQuantity: ([Number fromString: (xmlNode attributeAt: 'CompletionQuantity')] on: Error do: [:ex | nil]).

	self loopType: (loopNode attributeAt: 'LoopType').

	self setLoopCondtionWithNode: xmlNode.! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 12/30/2015 14:32'!
setMultiInstanceLoopConditionWith: xmlNode

	(xmlSegment findElementNamed: 'MI_Condition') 
		ifNotNil: [:loopCondNode | 
			loopCondNode nodes notEmpty ifTrue: [loopCondition := loopCondNode nodes last asString].
		].! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 12/30/2015 14:32'!
setStandardLoopConditionWith: xmlNode

	(xmlSegment findElementNamed: 'LoopCondition') 
		ifNotNil: [:loopCondNode | 
			loopCondNode nodes notEmpty ifTrue: [loopCondition := loopCondNode nodes last asString].
		].! !

XPDLActivityNode subclass: #XPDLScriptNode
	instanceVariableNames: 'script'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLScriptNode methodsFor: 'other' stamp: 'BrunoBB 06/22/2016 11:49'!
getArtifactFrom: aBpmProcessDefinition

	^aBpmProcessDefinition getScriptNamed: self getName ifNone: [nil]! !

!XPDLScriptNode methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 13:45'!
getLanesFrom: aXPDLPool

	^aXPDLPool getLanesForScriptNamed: self getName! !

!XPDLScriptNode methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 13:32'!
isScriptNode

	^true! !

!XPDLScriptNode methodsFor: 'Accessing' stamp: 'BrunoBB 06/21/2016 13:32'!
script
	^script! !

!XPDLScriptNode methodsFor: 'Updating' stamp: 'BrunoBB 06/21/2016 13:32'!
script: newValue
	script := newValue! !

!XPDLScriptNode methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 13:35'!
setInternalDataWithNode: xmlNode

	script := (xmlNode findElementNamed: 'Script')
					ifNil: [nil]
					ifNotNil: [:node | node contentString].! !

XPDLActivityNode subclass: #XPDLSubProcessNode
	instanceVariableNames: 'subProcess subProcessId isEmbedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLSubProcessNode class methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:07'!
newEmbedded

	^super new initialize
		isEmbedded: true;
		yourself! !

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:10'!
createBpmDefinitionOn: aBpmProcessDefinition
	"The receiver answer a sub instance of <BpmArtifactDefinition> that represent the XPDL element (the receiver) in the BPM model"

	^(super createBpmDefinitionOn: aBpmProcessDefinition)
			isEmbedded: isEmbedded;
			yourself! !

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:06'!
getLanesFrom: aXPDLPool

	^aXPDLPool getLanesForSubProcessTaskNamed: self getName! !

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:47'!
initialize

	super initialize.

	isEmbedded := false! !

!XPDLSubProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 06/26/2016 14:06'!
isEmbedded
	^isEmbedded! !

!XPDLSubProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 06/26/2016 14:06'!
isEmbedded: newValue
	isEmbedded := newValue! !

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:06'!
isSubProcessNode

	^true! !

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:06'!
setInternalDataWithNode: xmlNode
	"Set the <id> of the Subprocess of the receiver. The receiver will go to this subprocess when executed"

	self subProcessId: (
		(xmlNode findElementNamed: 'SubFlow')
		ifNotNil: [:resuableSubProc | resuableSubProc attributeAt: 'Id'] "reusable sub proc"
		ifNil: [(xmlNode findElementNamed: 'BlockActivity') attributeAt: 'Id'] "embedded sub proc"
	).! !

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:06'!
shortType

	^'Sub'! !

!XPDLSubProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 06/26/2016 14:06'!
subProcess
	^subProcess! !

!XPDLSubProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 06/26/2016 14:06'!
subProcess: newValue
	subProcess := newValue! !

!XPDLSubProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 06/26/2016 14:06'!
subProcessId
	^subProcessId! !

!XPDLSubProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 06/26/2016 14:06'!
subProcessId: newValue
	subProcessId := newValue! !

XPDLActivityNode subclass: #XPDLTaskNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLTaskNode methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 19:23'!
getLanesFrom: aXPDLPool

	^aXPDLPool getLanesForTaskNamed: self getName! !

!XPDLTaskNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:14'!
isTaskNode

	^true! !

!XPDLTaskNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:07'!
shortType

	^'F'! !

XPDLObject2 subclass: #XPDLEventNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLEventNode subclass: #XPDLEndNode
	instanceVariableNames: 'inTransitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 19:25'!
getLanesFrom: aXPDLPool

	^#()! !

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:02'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.! !

!XPDLEndNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:43'!
inTransitions
	^inTransitions! !

!XPDLEndNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:43'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:43'!
isEndNode

	^true! !

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:04'!
shortType

	^'E'! !

!XPDLEventNode methodsFor: 'other' stamp: 'BrunoBB 01/20/2016 11:31'!
isEventNode

	^true! !

!XPDLEventNode methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:04'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[',self getName, ']'.! !

XPDLEventNode subclass: #XPDLIntermediateNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLIntermediateNode methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 19:26'!
getLanesFrom: aXPDLPool

	^#()! !

XPDLEventNode subclass: #XPDLStartNode
	instanceVariableNames: 'outTransitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 19:25'!
getLanesFrom: aXPDLPool

	^#()! !

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:02'!
initialize

	super initialize.

	outTransitions := OrderedCollection new.! !

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:43'!
isStartNode

	^true! !

!XPDLStartNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:43'!
outTransitions
	^outTransitions! !

!XPDLStartNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:43'!
outTransitions: newValue
	outTransitions := newValue! !

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:03'!
shortType

	^'Str'! !

XPDLObject2 subclass: #XPDLGatewayNode
	instanceVariableNames: 'inTransitions outTransitions type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 19:10'!
getLanesFrom: aXPDLPool

	^aXPDLPool getLanesForGatewayNamed: self getName! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:23'!
hasMixedStartConditions
	"Answer whether or not the receiver has mixed start conditions.
	Some out Transitions has start condition and some Transitions has NO start condition"

	^(outTransitions anySatisfy: [:each | each startCondition notNil])
		and:[outTransitions anySatisfy: [:each | each startCondition isNil]]! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:28'!
hasNoInOrOutTransitions

	^inTransitions isEmpty and:[outTransitions isEmpty]! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
inTransitions
	^inTransitions! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 01/20/2016 11:32'!
isGatewayNode

	^true! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:27'!
outConditionsAreMandatory
	"Only -parallel- gateways has NO conditions "

	^(type = 'Parallel') not! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
outTransitions
	^outTransitions! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
outTransitions: newValue
	outTransitions := newValue! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:04'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[',self getName, ']'.! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
shortType

	^'G'! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
type
	^type! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
type: newValue
	type := newValue! !

XPDLObject2 subclass: #XPDLLaneNode
	instanceVariableNames: 'xpdlObjects pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLLaneNode methodsFor: 'rectangle area' stamp: 'BrunoBB 09/16/2016 10:48'!
absoluteRectangleIncludesActivity: aXPDLObject
	"Answer whether or not the xpdl object <aXPDLObject> is graphically contained inside the receiver"

	^self getAbsoluteRectangle containsPoint: aXPDLObject originPoint! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
addAllXpdlObject: aCollection

	^xpdlObjects addAll: aCollection! !

!XPDLLaneNode methodsFor: 'rectangle area' stamp: 'BrunoBB 09/16/2016 10:45'!
getAbsoluteRectangle
	"Answer a Rectangle that graphically represent the receiver"
	| xCoordinate yCoordinate |

	"the X and Y coordinates of the receiver does NOT includes the X and Y shift coordinate of the Pool.
	Lanes have a Relative Position (to their parent pool).
	Only for Lanes the shift is NOT included BUT Activity Nodes have an Absolute Position"
	xCoordinate := (self getXcoordinate) + (pool getXcoordinate). 
	yCoordinate := (self getYcoordinate) + (pool getYcoordinate). 

	^Rectangle 
		origin: (xCoordinate @ yCoordinate) 
		extent: (self valueOf: 'width') @ (self valueOf: 'height')! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
getAnyObjectNamed: aString ifNone: aBlock
	"Answer any subcomponent object in the receiver collection <xpdlObjects> with name <aString> if none evaluate the non argument block <aBlock>"

	^xpdlObjects detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
getGatewayNodes

	^xpdlObjects select: [:each | each isGatewayNode]! !

!XPDLLaneNode methodsFor: 'rectangle area' stamp: 'BrunoBB 09/16/2016 10:44'!
getRelativeRectangle
	"Answer a Rectangle that graphically represent the receiver"

	^Rectangle 
		origin: (self getXcoordinate @ self getYcoordinate) 
		extent: (self valueOf: 'width') @ (self valueOf: 'height')! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
getScriptNodes

	^xpdlObjects select: [:each | each isScriptNode]! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
getSubProcessNodes

	^xpdlObjects select: [:each | each isSubProcessNode]! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
getTaskNodes

	^xpdlObjects select: [:each | each isTaskNode]! !

!XPDLLaneNode methodsFor: 'graphics' stamp: 'BrunoBB 09/11/2016 08:57'!
getXcoordinate

	^pool getXcoordinate + (self valueOf: 'x')! !

!XPDLLaneNode methodsFor: 'graphics' stamp: 'BrunoBB 09/11/2016 08:57'!
getYcoordinate

	^pool getYcoordinate + (self valueOf: 'y')! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
hasGatewayNamed: aString

	^self getGatewayNodes anySatisfy: [:each | each getName = aString]! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
hasScriptNamed: aString

	^self getScriptNodes anySatisfy: [:each | each getName = aString]! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
hasSubProcessTaskNamed: aString

	^self getSubProcessNodes anySatisfy: [:each | each getName = aString]! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
hasTaskNamed: aString

	^self getTaskNodes anySatisfy: [:each | each getName = aString]! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 10:49'!
initialize

	super initialize.

	xpdlObjects := OrderedCollection new.! !

!XPDLLaneNode methodsFor: 'Accessing' stamp: 'BrunoBB 07/06/2016 10:49'!
pool
	^pool! !

!XPDLLaneNode methodsFor: 'Updating' stamp: 'BrunoBB 07/06/2016 10:49'!
pool: newValue
	pool := newValue! !

!XPDLLaneNode methodsFor: 'rectangle area' stamp: 'BrunoBB 09/16/2016 10:48'!
rectangleIncludesActivity: aXPDLObject
	"Answer whether or not the xpdl object <aXPDLObject> is graphically contained inside the receiver"

	^self getRelativeRectangle containsPoint: aXPDLObject originPoint! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 11:18'!
workflow

	^pool ifNotNil: [pool]! !

!XPDLLaneNode methodsFor: 'Accessing' stamp: 'BrunoBB 07/06/2016 10:49'!
xpdlObjects
	^xpdlObjects! !

!XPDLLaneNode methodsFor: 'Updating' stamp: 'BrunoBB 07/06/2016 10:49'!
xpdlObjects: newValue
	xpdlObjects := newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
addInTransition: aXPDLTransitionNode

	^self inTransitions add: aXPDLTransitionNode! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
addOutTransition: aXPDLTransitionNode

	^self outTransitions add: aXPDLTransitionNode! !

!XPDLObject2 methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 13:15'!
attributes

   "Return the value of the instance variable 'attributes'."
   ^attributes! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:15'!
attributes: newValue

   "Modify the value of the instance variable 'attributes'."
   attributes := newValue! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:15'!
completionQuantity: newValue

   "Modify the value of the instance variable 'name'."

	self set: 'completionQuantity' value: newValue! !

!XPDLObject2 methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 13:15'!
extendedAttributes
	^extendedAttributes! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:15'!
extendedAttributes: newValue
	extendedAttributes := newValue! !

!XPDLObject2 methodsFor: 'extended attributes' stamp: 'BrunoBB 12/13/2015 13:16'!
extendedValueOf: attrName

	^extendedAttributes at: attrName ifAbsent: [nil]! !

!XPDLObject2 methodsFor: 'extended attributes' stamp: 'BrunoBB 12/13/2015 13:16'!
extendedValueOf: attrName ifAbsent: aBlock

	^extendedAttributes at: attrName ifAbsent: aBlock! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
getCompletionQuantity

	^self valueOf: 'completionQuantity' ifAbsent: [nil]! !

!XPDLObject2 methodsFor: 'graphics' stamp: 'BrunoBB 07/06/2016 10:56'!
getHeight

	^self valueOf: 'height'! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
getId

	^self valueOf: 'id'! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 13:38'!
getLanesFrom: aXPDLPool

	self subclassResponsibility! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
getName

	^self valueOf: 'name' ifAbsent: ['']! !

!XPDLObject2 methodsFor: 'rectangle area' stamp: 'BrunoBB 09/16/2016 10:47'!
getRelativeRectangle
	"Answer a Rectangle that graphically represent the receiver"

	^Rectangle 
		origin: (self getXcoordinate @ self getYcoordinate) 
		extent: (self valueOf: 'width') @ (self valueOf: 'height')! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
getStartQuantity

	^self valueOf: 'startQuantity' ifAbsent: [nil]! !

!XPDLObject2 methodsFor: 'graphics' stamp: 'BrunoBB 07/06/2016 10:56'!
getWidth

	^self valueOf: 'width'! !

!XPDLObject2 methodsFor: 'graphics' stamp: 'BrunoBB 07/06/2016 10:57'!
getXcoordinate

	^self valueOf: 'x'! !

!XPDLObject2 methodsFor: 'graphics' stamp: 'BrunoBB 07/06/2016 10:57'!
getYcoordinate

	^self valueOf: 'y'! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:24'!
hasMixedStartConditions
	"Answer whether or not the receiver has mixed start conditions.
	Some out Transitions has start condition and some Transitions has NO start condition"

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:29'!
hasNoInOrOutTransitions

	^false! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:15'!
id: newValue

   "Modify the value of the instance variable 'id'."
	self set: 'id' value: newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
initialize

	super initialize.

	attributes := Dictionary new.
	extendedAttributes := Dictionary new.! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
inTransitions

	^OrderedCollection new! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 01/20/2016 11:31'!
isActivityNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
isEndNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 01/20/2016 11:31'!
isEventNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 01/20/2016 11:31'!
isGatewayNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 13:16'!
isScriptNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
isStartNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:25'!
isStartOrEndActivity

	^self isStartNode or: [self isEndNode]! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
isSubProcessNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
isTaskNode

	^false! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:15'!
name: newValue

   "Modify the value of the instance variable 'name'."

	self set: 'name' value: newValue! !

!XPDLObject2 methodsFor: 'graphics' stamp: 'BrunoBB 07/06/2016 10:57'!
originPoint

	^self getXcoordinate @ self getYcoordinate! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
outTransitions

	^OrderedCollection new! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/30/2015 14:41'!
performers

	^#()! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
prettyPrinted

	^xmlSegment prettyPrinted! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
removeAttribute: attrName 

	^attributes removeKey: attrName ifAbsent: []! !

!XPDLObject2 methodsFor: 'extended attributes' stamp: 'BrunoBB 12/13/2015 13:17'!
removeExtendedAttribute: attrName 

	^extendedAttributes removeKey: attrName ifAbsent: []! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
set: attrName value: anObject

	^attributes at: attrName put: anObject! !

!XPDLObject2 methodsFor: 'extended attributes' stamp: 'BrunoBB 04/10/2016 15:51'!
setExtendedAttribute: attrName value: anObject

	^extendedAttributes at: attrName put: anObject! !

!XPDLObject2 methodsFor: 'extended attributes' stamp: 'BrunoBB 12/13/2015 13:18'!
setExtendedAttributes

	^self setExtendedAttributesWithNode: xmlSegment! !

!XPDLObject2 methodsFor: 'extended attributes' stamp: 'BrunoBB 04/09/2016 12:55'!
setExtendedAttributesWithNode: xmlNode
	"The receiver set the extended attributes <expectedResult> and <transitionPreviousFields> supported by the Process Engine"

	xmlNode allElementsNamed: 'ExtendedAttribute' do: [:eachAttr | | nodeValue |
		"-extended attribute- a TextArea in Bizagi Modeler (value is a XML)"
		"-extended attribute- a TextBox in Bizagi Modeler (value is a string)"
		nodeValue := ((eachAttr attributeAt: 'Name') = 'expectedResult')  
			ifTrue: [(XMLDOMParser parse: (eachAttr attributeAt: 'Value')) contentString]
			ifFalse: [eachAttr attributeAt: 'Value']. 

		self setExtendedAttribute: (eachAttr attributeAt: 'Name') value: nodeValue.
	].! !

!XPDLObject2 methodsFor: 'graphics' stamp: 'BrunoBB 09/11/2016 15:25'!
setGraphicActivityValuesWithNode: xmlNode
	"We set the graphic information of <newActivity> using the XML node <xmlNode>"
	| gNode |

	gNode := xmlNode findElementNamed: 'NodeGraphicsInfo'.
	self set: 'width' value: (Number readFrom: (gNode attributeAt: 'Width')).
	self set: 'height' value: (Number readFrom: (gNode attributeAt: 'Height')).

	gNode := xmlNode findElementNamed: 'Coordinates'.
	self set: 'x' value: (Number readFrom: (gNode attributeAt: 'XCoordinate')).
	self set: 'y' value: (Number readFrom: (gNode attributeAt: 'YCoordinate')).! !

!XPDLObject2 methodsFor: 'graphics' stamp: 'BrunoBB 07/06/2016 11:16'!
setGraphicValues
	"We set the graphic information of <newLane> using the XML node <xmlNode>"

	self setGraphicValuesWithNode: xmlSegment! !

!XPDLObject2 methodsFor: 'graphics' stamp: 'BrunoBB 07/06/2016 11:59'!
setGraphicValuesWithNode: xmlNode
	"We set the graphic information of <newLane> using the XML node <xmlNode>"
	| gNode |

	gNode := xmlNode xPath: './NodeGraphicsInfos/NodeGraphicsInfo'.
	gNode := gNode ifNotEmpty: [gNode last] ifEmpty: [^self].
	self set: 'width' value: (Number readFrom: (gNode attributeAt: 'Width')).
	self set: 'height' value: (Number readFrom: (gNode attributeAt: 'Height')).

	gNode := gNode findElementNamed: 'Coordinates'.
	self set: 'x' value: (Number readFrom: (gNode attributeAt: 'XCoordinate')).
	self set: 'y' value: (Number readFrom: (gNode attributeAt: 'YCoordinate')).! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 13:30'!
setInternalDataWithNode: xmlNode! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
setLoopTypeWithNode: xmlNode
	"The receiver set it's loop type from the xml node <xmlNode>
	Loop type: (none) (standart) (multi-instance)"! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
shortType

	^'xpdl'! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:15'!
startQuantity: newValue

   "Modify the value of the instance variable 'name'."

	self set: 'startQuantity' value: newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
valueOf: attrName

	^attributes at: attrName ifAbsent: [nil]! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:15'!
valueOf: attrName ifAbsent: aBlock

	^attributes at: attrName ifAbsent: aBlock! !

!XPDLObject2 methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 13:15'!
xmlSegment
	^xmlSegment! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:15'!
xmlSegment: newValue
	xmlSegment := newValue! !

XPDLObject2 subclass: #XPDLPackageNode
	instanceVariableNames: 'xpdlReader pools participants associations artifacts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLPackageNode class methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:59'!
newOn: aXPDLReader2

	^super new initialize
		xpdlReader: aXPDLReader2;
		yourself! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:58'!
addParticipant: aXPDLParticipantNode

	^participants at: aXPDLParticipantNode getName put: aXPDLParticipantNode! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:58'!
addPool: aXPDLPoolNode

	^pools at: aXPDLPoolNode getName put: aXPDLPoolNode! !

!XPDLPackageNode methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:58'!
artifacts
	^artifacts! !

!XPDLPackageNode methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:58'!
artifacts: newValue
	artifacts := newValue! !

!XPDLPackageNode methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:58'!
associations
	^associations! !

!XPDLPackageNode methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:58'!
associations: newValue
	associations := newValue! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:58'!
createParticipants
	"The receiver creates and add to the receiver all participants contained in XML Document <aXMLDocument>"

	^self createParticipantsFrom: xmlSegment! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:58'!
createParticipantsFrom: aXMLDocument

	aXMLDocument allElementsNamed: 'Participant' do: [:xmlParticipantNode | | newParticipant |
		newParticipant := XPDLParticipantNode new 
								xmlSegment: xmlParticipantNode;
								id: (xmlParticipantNode attributeAt: 'Id');
								name: (xmlParticipantNode attributeAt: 'Name');
								type: ((xmlParticipantNode findElementNamed: 'ParticipantType') ifNotNil: [:node | node attributeAt: 'Type']);
								yourself.

		self addParticipant: newParticipant.].

	^participants! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 07/06/2016 11:15'!
createXpdlComponents

	xmlSegment allElementsNamed: 'Pool' do: [:eachPool | | newPool |
		((eachPool attributeAt: 'Name') = 'Main Process') "this represent the main sheet in Bizagi"
		ifFalse: [newPool := XPDLPoolNode new
										package: self;
										xmlSegment: eachPool;
										sheetName: self getName;
										id: (eachPool attributeAt: 'Id');
										name: (eachPool attributeAt: 'Name');
										workflowId: (eachPool attributeAt: 'Process');
										yourself.
					newPool 
						setGraphicValues; "set the graphics values -x,y, width, height-"
						createLanes; "create lanes in the Pool"
						createWorkflowFrom: xmlSegment; "create the associated Workflow with the Pool "
						setLanesComponents. "add the subcomponents (tasks, gateways, ...) to the it's parent lane"
					self addPool: newPool].
	].! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:52'!
getAllSubProcessNodes
	| all |

	all := OrderedCollection new.
	pools do: [:each | all addAll: each getSubProcessNodes].

^all! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:58'!
getPoolNamed: aString ifNone: aBlock

	^pools at: aString ifAbsent: aBlock! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:58'!
getWorkflowNamed: aString ifNone: aBlock

	^(self getPoolNamed: aString ifNone: [^nil]) workflow! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:18'!
getWorkflows

	^pools collect: [:each | each workflow]! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:07'!
hasParentProcess
	"Answer whether or not the receiver has parent process"

	^xpdlReader hasParentProcess: self! !

!XPDLPackageNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:58'!
initialize

	super initialize.

	pools := Dictionary new.
	participants := Dictionary new.
	associations := Dictionary new.
	artifacts := Dictionary new.! !

!XPDLPackageNode methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:58'!
participants
	^participants! !

!XPDLPackageNode methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:58'!
participants: newValue
	participants := newValue! !

!XPDLPackageNode methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:58'!
pools
	^pools! !

!XPDLPackageNode methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:58'!
pools: newValue
	pools := newValue! !

!XPDLPackageNode methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:58'!
xpdlReader
	^xpdlReader! !

!XPDLPackageNode methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:58'!
xpdlReader: newValue
	xpdlReader := newValue! !

XPDLObject2 subclass: #XPDLParticipantNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLParticipantNode methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 13:28'!
getType

	^self valueOf: 'type'! !

!XPDLParticipantNode methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 13:27'!
type: newValue

   "Modify the value of the instance variable 'id'."
	self set: 'type' value: newValue! !

XPDLObject2 subclass: #XPDLPoolNode
	instanceVariableNames: 'package lanes processId workflow workflowId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
activities

	^workflow activities! !

!XPDLPoolNode methodsFor: 'component creation' stamp: 'BrunoBB 07/06/2016 10:50'!
addLane: aXPDLLaneNode

	aXPDLLaneNode pool: self.
	^lanes at: aXPDLLaneNode getName put: aXPDLLaneNode! !

!XPDLPoolNode methodsFor: 'component creation' stamp: 'BrunoBB 10/31/2015 14:33'!
createLanes
	"The receiver creates and add to lanes collection <lanes> all lanes contained in XML Document <aXMLDocument>"

	^self createLanesFrom: xmlSegment! !

!XPDLPoolNode methodsFor: 'component creation' stamp: 'BrunoBB 07/06/2016 11:16'!
createLanesFrom: aXMLDocument
	"The receiver creates and add to lanes collection <lanes> all lanes contained in XML Document <aXMLDocument>"

	aXMLDocument allElementsNamed: 'Lane' do: [:xmlLaneNode | | newLane |
		newLane := XPDLLaneNode new 
								xmlSegment: xmlLaneNode;
								id: (xmlLaneNode attributeAt: 'Id');
								name: (xmlLaneNode attributeAt: 'Name');
								yourself.
		newLane setGraphicValues. "set the graphics values -x,y, width, height-"

		self addLane: newLane.].

	^lanes! !

!XPDLPoolNode methodsFor: 'component creation' stamp: 'BrunoBB 07/06/2016 11:18'!
createWorkflowFrom: aXMLDocument
	"The receiver creates all workflows contained in XML document <aXMLDocument>"

	aXMLDocument allElementsNamed: 'WorkflowProcess' do: [:xmlWorkflow | | newWorkflow |
		((xmlWorkflow attributeAt: 'Id') = workflowId)
		ifTrue: [newWorkflow := XPDLWorkflowProcess new 
								xmlSegment: xmlWorkflow;
								id: (xmlWorkflow attributeAt: 'Id');
								name: (xmlWorkflow attributeAt: 'Name');
								yourself.
					self workflow: newWorkflow.
					newWorkflow 
						setGraphicValues; "set the graphics values -x,y, width, height-"
						createActivityNodes; 
						createTransitionNodes;
						setStartAndEndNodes;
						connectActivitiesToParentLane;
						connectActivitiesAndTrasitions;
						createEmbeddedSubProcesses.
		].
	].

	^lanes! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 06/27/2016 10:30'!
getAllEmbbeddedProcesses

	^workflow getAllEmbbeddedProcesses! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getAnyObjectNamed: aString ifNone: aBlock

	^workflow getAnyObjectNamed: aString ifNone: aBlock! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getEndNodeNamed: aString ifNone: aBlock

	^workflow getEndNodeNamed: aString ifNone: aBlock! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getEndNodes

	^workflow endNodes! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getGatewayNamed: aString ifNone: aBlock

	^workflow getGatewayNamed: aString ifNone: aBlock! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getGatewayNodes

	^workflow getGatewayNodes! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getLaneNamed: aString ifNone: aBlock

	^lanes at: aString ifPresent: [:value | value] ifAbsent: aBlock! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getLanesForGatewayNamed: aString

	^lanes select: [:each | each hasGatewayNamed: aString]! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 06/21/2016 13:45'!
getLanesForScriptNamed: aString

	^lanes select: [:each | each hasScriptNamed: aString]! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getLanesForSubProcessTaskNamed: aString

	^lanes select: [:each | each hasSubProcessTaskNamed: aString]! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getLanesForTaskNamed: aString

	^lanes select: [:each | each hasTaskNamed: aString]! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 06/22/2016 10:20'!
getScriptNodes

	^workflow getScriptNodes! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:33'!
getSheetName

	^self valueOf: 'sheetName' ifAbsent: [nil]! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getStartNode

	^workflow startNode! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getSubprocessNamed: aString ifNone: aBlock

	^workflow getSubprocessNamed: aString ifNone: aBlock! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getSubProcessNodes

	^workflow getSubProcessNodes! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getTaskNamed: aString ifNone: aBlock

	^workflow getTaskNamed: aString ifNone: aBlock! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getTaskNodes

	^workflow getTaskNodes! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
getTransitionNamed: aString ifNone: aBlock

	^workflow getTransitionNamed: aString ifNone: aBlock! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:09'!
hasParentProcess

	^package hasParentProcess! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:33'!
initialize

	super initialize.

	lanes := Dictionary new.! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 14:33'!
lanes
	^lanes! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 14:33'!
lanes: newValue
	lanes := newValue! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 14:33'!
package
	^package! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 14:33'!
package: newValue
	package := newValue! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 12/31/2015 13:33'!
performers

	^self package participants! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 14:33'!
processId
	^processId! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 14:33'!
processId: newValue
	processId := newValue! !

!XPDLPoolNode methodsFor: 'component creation' stamp: 'BrunoBB 09/16/2016 10:50'!
setLanesComponents
	"The receiver add all subcomponents to each corresponding XPDLLane in <xpdlObjects> collection"
	| activities |

	activities := self activities.

	lanes do: [:eachLane | 
		eachLane addAllXpdlObject: (activities select: [:eachAct | eachLane rectangleIncludesActivity: eachAct])]! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:33'!
sheetName: aString

	self set: 'sheetName' value: aString! !

!XPDLPoolNode methodsFor: 'searching' stamp: 'BrunoBB 10/31/2015 14:33'!
transitions

	^workflow transitions! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 14:33'!
workflow
	^workflow! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 14:33'!
workflow: aXPDLWorkflowProcess

	workflow := aXPDLWorkflowProcess.

	aXPDLWorkflowProcess parentPool: self! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 14:33'!
workflowId
	^workflowId! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 14:33'!
workflowId: newValue
	workflowId := newValue! !

XPDLObject2 subclass: #XPDLTransitionNode
	instanceVariableNames: 'startNode endNode startId endId startCondition roles isDefaultFlow coordinates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 14:04'!
coordinates
	^coordinates! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 14:04'!
coordinates: newValue
	coordinates := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 14:04'!
endId
	^endId! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 14:04'!
endId: newValue
	endId := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 14:04'!
endNode
	^endNode! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 14:04'!
endNode: newValue
	endNode := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/13/2016 09:00'!
endNodeName
	^self endNode getName! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 04:00'!
hasCondition

	^startCondition notNil and: [startCondition notEmpty]! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 14:05'!
initialize

	super initialize.

	roles := OrderedCollection new.
	isDefaultFlow := false.
	coordinates := OrderedCollection new.! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 14:04'!
isDefaultFlow
	^isDefaultFlow! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 14:04'!
isDefaultFlow: newValue
	isDefaultFlow := newValue! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 14:04'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: 
					'[(',
					(startNode ifNil: ['NoStNode'] ifNotNil: [:value | value shortType]), 
					')', 
					(startNode ifNil: ['NoStNode'] ifNotNil: [:value | value getName]), 
					'>>', 
					(endNode ifNil: ['NoEndNode'] ifNotNil: [:value | value getName]), 
					'(', 
					(endNode ifNil: ['NoEndNode'] ifNotNil: [:value | value shortType]), 
					')]'.! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 14:04'!
roles
	^roles! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 14:04'!
roles: newValue
	roles := newValue! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 14:04'!
setAsDefaultFlow

	isDefaultFlow := true! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 14:08'!
setGraphicValuesWithNode: xmlNode
	"We set the graphic information of <newLane> using the XML node <xmlNode>"

	(xmlNode xPath: './ConnectorGraphicsInfos/ConnectorGraphicsInfo/Coordinates') do: [:eachNode | | x y |
		x := Number readFrom: (eachNode attributeAt: 'XCoordinate').
		y := Number readFrom: (eachNode attributeAt: 'YCoordinate').
		coordinates add: x @ y.
	].! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 14:04'!
startCondition
	^startCondition! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 14:04'!
startCondition: newValue
	startCondition := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 14:04'!
startId
	^startId! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 14:04'!
startId: newValue
	startId := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 14:04'!
startNode
	^startNode! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 14:04'!
startNode: newValue
	startNode := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/13/2016 09:00'!
startNodeName
	^self startNode getName! !

XPDLObject2 subclass: #XPDLWorkflowProcess
	instanceVariableNames: 'parentPool startNode endNodes lanes activities transitions processId embeddedSubprocesses parentWorkflow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:27'!
activities
	^activities! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:27'!
activities: newValue
	activities := newValue! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 06/25/2016 13:27'!
addActivity: activityEventGateway

	^activities at: activityEventGateway getName put: activityEventGateway! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 17:12'!
addEmbeddedWorkflow: aXPDLWorkflowProcess

	aXPDLWorkflowProcess parentWorkflow: self. 
	^embeddedSubprocesses at: aXPDLWorkflowProcess getName put: aXPDLWorkflowProcess! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 06/25/2016 13:27'!
addTransition: aXPDLLaneNode

	^transitions add: aXPDLLaneNode! !

!XPDLWorkflowProcess methodsFor: 'import warning' stamp: 'BrunoBB 06/25/2016 13:27'!
appendFormsWithMissingMandatoryFieldsIn: anOrbeonApplication to: anOrderedCollection

	(activities reject: [:each | each isGatewayNode])
		do:[:each | | def |
					def := anOrbeonApplication definitionNamed: each getName.
					def ifNotNil: [ 
						def getMandatoryFieldsMissing do: [:eachName | | item |
							item := XPDLItemImportReport new type: 'Error';
										title: 'Missing Mandatory Field';
										description: 'Form [', def formName, '] in Orbeon Application [', anOrbeonApplication applicationName, '] has NO mandatory field [', eachName ,']';
										solution: 'Add missing mandatory fields to the Form Definition. Mandatori fields (s, k, oop, uuid, assignmentOop, username, rol, formId)';
									yourself.
							anOrderedCollection add: item]]].

	^anOrderedCollection! !

!XPDLWorkflowProcess methodsFor: 'import warning' stamp: 'BrunoBB 06/25/2016 13:27'!
appendNonExistingFormsReportFor: anOrbeonApplication to: anOrderedCollection

	(self getNonExistingFormNamesIn: anOrbeonApplication) do: [:formName | | itemReport |
		itemReport := XPDLItemImportReport new type: 'Error';
			title: 'Missing Orbeon Form';
			description: 'Form [', formName, '] does not exist in Orbeon Application [', anOrbeonApplication applicationName, ']';
			solution: 'Create the Form Definition in Orbeon Form Builder';
			yourself.
		anOrderedCollection add: itemReport.].! !

!XPDLWorkflowProcess methodsFor: 'import warning' stamp: 'BrunoBB 06/25/2016 13:27'!
appendNonExistingRolesReportFor: anOrbeonApplication to: anOrderedCollection

	(self getNonExistingRolesNamesIn: anOrbeonApplication) do: [:rolName | | itemReport |
		itemReport := XPDLItemImportReport new type: 'Warning';
			title: 'Missing Role';
			description: 'Role named [', rolName, '] does not exist in Orbeon Application [', anOrbeonApplication applicationName, ']';
			solution: 'Add the role to the Orbeon Application';
			yourself.
		anOrderedCollection add: itemReport.].! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 06/25/2016 13:27'!
connectActivitiesAndTrasitions
	"The receiver connect/set each transition's <startNode> and <endNode> with the corresponding XPDL Object"

	self transitions do: [:eachTr | "connect transition start and end node with XPLDActivities"
		eachTr startNode: 
				(activities detect: [:eachAct | eachAct getId = eachTr startId] ifNone: [nil]).
		eachTr endNode: 
				(activities detect: [:eachAct | eachAct getId = eachTr endId] ifNone: [nil]).
		eachTr startNode addOutTransition: eachTr.
		eachTr endNode addInTransition: eachTr.].! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 09/16/2016 10:50'!
connectActivitiesToParentLane
	"The receiver connect/set all XPDL subcomponents for each corresponding XPDL Lane.
	Also set the role for each transition"

	self lanes do: [:eachLane | "set the role of each transition -each activity inTransitions-"
		eachLane xpdlObjects: (self activities select: [:eachAct | eachLane absoluteRectangleIncludesActivity: eachAct]).
		"add the rol for each transition"
		eachLane xpdlObjects do: [:eachAct | 
			eachAct inTransitions do: [:eachTr | eachTr roles: (OrderedCollection with: eachLane getName)]]
	].! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 06/25/2016 13:27'!
createActivityNodes
	"The receiver creates and adds all activities contained in XML document <aXMLDocument> to it's activities collection <activities>"

	^self createActivityNodesFrom: xmlSegment! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 06/25/2016 14:07'!
createActivityNodesFrom: aXMLDocument
	"The receiver creates and adds all activities contained in XML document <aXMLDocument> to it's activities collection <activities>"
	| performers |

	performers := self getAllPerformers.
	(aXMLDocument xPath: 'Activities/Activity') do: [:eachNode | | newActivity |
		newActivity := (self getActivityInstanceFrom: eachNode)
			id: (eachNode attributeAt: 'Id');
			name: (eachNode attributeAt: 'Name');
			xmlSegment: eachNode; 
			yourself.
		newActivity 
			setExtendedAttributesWithNode: eachNode;
			setLoopTypeWithNode: eachNode; "loop type: (none) (standart) (multi-instance) [only for Tasks and Subprocess nodes ]"
			setGraphicActivityValuesWithNode: eachNode; "set graphic coordinates [for all nodes]"
			setInternalDataWithNode: eachNode. "set the Id of the subprocess [only for Subprocess nodes]"

		eachNode allElementsNamed: 'Performer' do: [:performerNode | | activityPerformId |
			activityPerformId := performerNode nodes last asString.
			(performers detect: [:each | each getId = activityPerformId] ifNone: [nil])
			ifNotNil: [:performer | newActivity addPerformer: performer].
		].
		self addActivity: newActivity.].

	^activities! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 07/06/2016 11:16'!
createEmbeddedSubProcesses
	"The receiver create the embedded subprocess"
	| embeddedSubProcs |

	embeddedSubProcs := OrderedCollection new.
	xmlSegment allElementsNamed: 'ActivitySet' do: [:xmlActivitySet | | newWorkflow | 
		newWorkflow := XPDLWorkflowProcess new 
										xmlSegment: xmlActivitySet;
										id: (xmlActivitySet attributeAt: 'Id');
										name: (xmlActivitySet attributeAt: 'Name');
										parentWorkflow: self;
										yourself.
		newWorkflow 
			setGraphicValues; "set the graphics values -x,y, width, height-"
			createActivityNodesFrom: xmlActivitySet; 
			createTransitionNodesFrom: xmlActivitySet;
			setStartAndEndNodes;
			"connectActivitiesToParentLane;"  "embedded suprocess does NOT have lanes by standart"
			connectActivitiesAndTrasitions.
		embeddedSubProcs add: newWorkflow.
	].
	embeddedSubProcs do: [:eachWorkflow1 |
		embeddedSubProcs do: [:eachWorkflow2 | 
			(eachWorkflow2 activities anySatisfy: [:each | eachWorkflow1 getId = each getId])
			ifTrue: [eachWorkflow2 addEmbeddedWorkflow: eachWorkflow1].
		].
	].

	(embeddedSubProcs select: [:each | each parentWorkflow == self]) do: [:each | self addEmbeddedWorkflow: each].! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 06/25/2016 13:27'!
createTransitionNodes
	"The receiver creates and adds all transitions contained in XML document <aXMLDocument> to it's transition collection <transitions>"

	^self createTransitionNodesFrom: xmlSegment! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 09/11/2016 13:54'!
createTransitionNodesFrom: aXMLDocument
	"The receiver creates and adds all transitions contained in XML document <aXMLDocument> to it's transition collection <transitions>"

	(aXMLDocument xPath: 'Transitions/Transition') do: [:eachNode | | newTransition startCond isDefaultFlow |
		(eachNode findElementNamed: 'Condition') 
			ifNotNil: [:condNode | isDefaultFlow := (condNode attributeAt: 'Type') = 'OTHERWISE'].
		startCond := eachNode findElementNamed: 'Expression'.
		startCond ifNotNil: [startCond := startCond contentString].
		newTransition := XPDLTransitionNode new 
									xmlSegment: eachNode;
									id: (eachNode attributeAt: 'Id');
									name: (eachNode attributeAt: 'Name');
									startId: (eachNode attributeAt: 'From');
									endId: (eachNode attributeAt: 'To');
									startCondition: startCond;
									isDefaultFlow: isDefaultFlow;
									yourself.
		newTransition setExtendedAttributes; setGraphicValues.
		self addTransition: newTransition.].

	^transitions! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:27'!
embeddedSubprocesses
	^embeddedSubprocesses! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:27'!
embeddedSubprocesses: newValue
	embeddedSubprocesses := newValue! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:27'!
endNodes
	^endNodes! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:27'!
endNodes: newValue
	endNodes := newValue! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getActivitiesWithMixedStartConditions
	"Answer a collection of <XPDLActivity> where some <XPDLTransition> has <startCondition> and others NOT.
	By general rule if an out Transition has a <startCondition> then all others out Transitions should have too.
	This is a only a Warning because could be a case where the previous does not apply"
	| report |

	report := OrderedCollection new.

	(activities select: [:eachAct | eachAct hasMixedStartConditions]) do: [:eachAct | | reportItem |
		reportItem := XPDLItemImportReport new type: 'Warning';
			title: 'Mixed Start Conditions';
			description: 'Activity [', eachAct getName, '] in Process [', self getName, '] has Mixed Start Conditions (maybe not an error)';
			solution: 'If it is applicable: Add a condition to all transitions or remove all conditions from all transitions';
			yourself.
		report add: reportItem.
		].

	^report! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getActivitiesWithoutName
	"Answer a collection of <XPDLActivity> without name.
	Activities MUST have a name."
	| report |

	report := OrderedCollection new.

	(activities select: [:each | each getName isNil or:[each getName isEmpty]]) do: [:eachAct | | reportItem |
		reportItem := XPDLItemImportReport new type: 'Error';
			title: 'Activities without Name';
			description: 'Activity type [', eachAct getName, '] in Process [', self getName, '] without name';
			solution: 'Add a name to the Activity';
			yourself.
		report add: reportItem].

	^report! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getActivitiesWithSameName
	"Answer a collection of <XPDLActivity> with the same name.
	Activities can NOT have the same name."

	^self getActivitiesWithSameNameIn: Dictionary new! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getActivitiesWithSameNameIn: aDictionary
	"Answer a collection of <XPDLActivity> with the same name.
	Activities can NOT have the same name."
	| report |

	report := OrderedCollection new.

	(activities reject: [:each | each isStartOrEndActivity]) do: [:each | 
		aDictionary at: each getName 
			ifPresent: [:value | aDictionary at: each getName put: value + 1] 
			ifAbsent: [aDictionary at: each getName put: 1].
	(aDictionary select: [:eachValue | eachValue > 1]) keysAndValuesDo: [:key :value | | reportItem |
		reportItem := XPDLItemImportReport new type: 'Error';
			title: 'Activities with same Name';
			description: 'Activity [', key, '] in Process [', self getName, '] is repeated';
			solution: 'Delete or rename one of the activities';
			yourself.
		report add: reportItem].
	].
	^report! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 06/26/2016 14:45'!
getActivityInstanceFrom: xmlActivityNode
	"The receiver answer the most fittable XPDL class to represent the xml node <xmlActivityNode>"

	(xmlActivityNode findElementNamed: 'SubFlow') ifNotNil: [^XPDLSubProcessNode new]."Reusable Subprocess"
	(xmlActivityNode findElementNamed: 'BlockActivity') ifNotNil: [:blockActNode | 
		(blockActNode attributeAt: 'ActivitySetId' ifAbsent: [nil]) ifNotNil: [^XPDLSubProcessNode newEmbedded]]. "Embedded Subprocess"

	(xmlActivityNode findElementNamed: 'Route') 
	ifNotNil: [:node | | gate type | 
		gate := XPDLGatewayNode new.
		type := node attributeAt: 'GatewayType' ifAbsent: ['']. "set the type of the gateway"
		^gate type: type].

	(xmlActivityNode findElementNamed: 'StartEvent') ifNotNil: [^XPDLStartNode new].

	(xmlActivityNode findElementNamed: 'EndEvent') ifNotNil: [^XPDLEndNode new].

	(xmlActivityNode findElementNamed: 'Script') ifNotNil: [^XPDLScriptNode new].

	^XPDLTaskNode new! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/27/2016 10:32'!
getAllEmbbeddedProcesses
	| all |

	all := OrderedCollection new.

	embeddedSubprocesses do: [:each | each getAllEmbbeddedProcesses: all].

	^all! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/27/2016 10:33'!
getAllEmbbeddedProcesses: anOrderedCollection

	anOrderedCollection add: self.

	embeddedSubprocesses do: [:each | each getAllEmbbeddedProcesses: anOrderedCollection].

	^anOrderedCollection! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 13:30'!
getAllPerformers

	self isEmbedded ifTrue: [^parentWorkflow getAllPerformers]. "go to the parent workflow because is an embbeded process"

	^parentPool performers! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getAnyObjectNamed: aString ifNone: aBlock

	^self getTaskNamed: aString
			ifNone: [self getGatewayNamed: aString 
				ifNone: [self getSubprocessNamed: aString
					ifNone: [self getEndNodeNamed: aString ifNone: [nil]]]]! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getEndNodeNamed: aString ifNone: aBlock

	^endNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getEndNodesReport
	| report reportItem |

	self hasEndNodes ifTrue: [^#()].

	report := OrderedCollection new.
	reportItem := XPDLItemImportReport new type: 'Error';
		title: 'Process without End';
		description: 'Process [', self getName, '] does NOT have End Node';
		solution: 'Create an end node in the Process definition';
		yourself.
	report add: reportItem.

	^report! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getGatewayNamed: aString ifNone: aBlock

	^self getGatewayNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getGatewayNodes

	^activities select: [:each | each isGatewayNode]! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 09/13/2016 04:01'!
getGatewaysWithoutConditions
	"Answer a collection of <XPDLActivity> with the same name.
	Activities can NOT have the same name."
	| report activitiesNames |

	report := OrderedCollection new.

	activitiesNames := Dictionary new.
	(activities select: [:each |each isGatewayNode and: [each outConditionsAreMandatory]]) do: [:xpdlGateway | 
			(xpdlGateway outTransitions reject: [:eachTr | eachTr hasCondition]) do: [:eachTr | | reportItem |		
				reportItem := XPDLItemImportReport new type: 'Error';
					title: 'Gateway without condition';
					description: 'Gateway [', xpdlGateway getName, '] in Process [', self getName, '] has no condition for out going transition [', eachTr getName, ']';
					solution: 'Define all conditions for all out going transitions in this Gateway';
					yourself.
				report add: reportItem].
	].

	^report! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getIsolatedActivities
	"Answer a collection of <XPDLActivity> where has not IN or OUT <XPDLTransition> "
	| report |

	report := OrderedCollection new.

	self getIsolatedActivitiesNodes do: [:eachAct | | reportItem |
		reportItem := XPDLItemImportReport new type: 'Warning';
			title: 'Isolated Activity';
			description: 'Activity [', eachAct getName, '] in Process [', self getName, '] is Isolated';
			solution: 'Delete the Activity or connect the Activity to some other element in the Process definition';
			yourself.
		report add: reportItem.
		].

	^report! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getIsolatedActivitiesNodes

	^activities select: [:each | each hasNoInOrOutTransitions]! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 09/13/2016 04:27'!
getLaneMaxYCoordinate

	^self parentLanes
		ifEmpty: [^0]
		ifNotEmpty: [:collection | | lane |
			lane := (collection asSortedCollection: [:a :b | a getYcoordinate >= b getYcoordinate]) first.
			lane getYcoordinate + lane getHeight + 10] "the most bottom point of all lanes"! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getLaneNamed: aString ifNone: aBlock

	^lanes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 13:59'!
getLanesForGatewayNamed: aString

	^self isEmbedded
	ifFalse: [parentPool getLanesForGatewayNamed: aString]
	ifTrue: [parentWorkflow getLanesForGatewayNamed: aString].! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 13:59'!
getLanesForScriptNamed: aString

	^self isEmbedded
	ifFalse: [parentPool getLanesForScriptNamed: aString]
	ifTrue: [parentWorkflow getLanesForScriptNamed: aString].! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 13:59'!
getLanesForSubProcessTaskNamed: aString

	^self isEmbedded
	ifFalse: [parentPool getLanesForSubProcessTaskNamed: aString]
	ifTrue: [parentWorkflow getLanesForSubProcessTaskNamed: aString].! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 14:00'!
getLanesForTaskNamed: aString

	^self isEmbedded
	ifFalse: [parentPool getLanesForTaskNamed: aString]
	ifTrue: [parentWorkflow getLanesForTaskNamed: aString].! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getLanesWithoutName
	""
	| report |

	report := OrderedCollection new.

	(lanes select: [:each | each getName notNil and: [each getName notEmpty]]) do: [:eachLane | | reportItem |
		reportItem := XPDLItemImportReport new type: 'Warning';
			title: 'Lane without name';
			description: 'The Lane [', eachLane getName, '] in Process [', self getName, '] has no name';
			solution: 'Edit the Process definition and set the name of the lane';
			yourself.
		report add: reportItem.
		].

	^report! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getNonExistingFormNamesIn: anOrbeonApplication
	"Answer a collection with the names of the forms that are defined in the XPDL but not defined in the system.

	Right now only checks for OrbeonApplication, but must work with general Application (subclass of AbstractApplication)"

	^((activities reject: [:each | each isGatewayNode])
		reject: [:each | (anOrbeonApplication hasDefinitionNamed: each getName) 
															or:[each isEventNode or:[each isSubProcessNode]]])
			collect: [:each | each getName]! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getNonExistingRolesNamesIn: anOrbeonApplication

	^(lanes reject: [:each | BpmFrontOfficeRole hasRoleNamed: each getName in: anOrbeonApplication])
			collect: [:each | each getName].! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 07/06/2016 12:40'!
getScriptNamed: aString ifNone: aBlock

	^self getScriptNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getScriptNodes

	^activities select: [:each | each isScriptNode]! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/27/2016 12:37'!
getSheetName

	^self isEmbedded
	ifFalse: [parentPool getSheetName]
	ifTrue: [parentWorkflow getSheetName].! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getStartNodeReport
	| report reportItem |

	self hasStartNode ifTrue: [^#()].

	report := OrderedCollection new.
	reportItem := XPDLItemImportReport new type: 'Error';
		title: 'Process without Start';
		description: 'Process [', self getName, '] does NOT have a Start Node';
		solution: 'Create a Start node in the Process definition';
		yourself.
	report add: reportItem.

	^report! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getSubprocessNamed: aString ifNone: aBlock

	^self getSubProcessNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getSubProcessNodes

	^activities select: [:each | each isSubProcessNode]! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getSuspiciousConditions
	"Answer a collection with wrong or suspicious code inside gateways or transitions definitions.
	Conditions in gateways or transitions MUST answer a boolean and MUST send messages only to the argument of the Block.
	[:form | form amount >1000] is OK, but [:form | SomeClass doSomethigSuspicious] must be banned."
	| report |

	report := OrderedCollection new.

	(transitions select: [:eachTr | eachTr startCondition notNil]) do: [:eachTr | | blockAnalysis | 
		blockAnalysis := BpmGatewayConditionCodeAnalyzer new blockCode: eachTr startCondition.
		blockAnalysis analyze.
		blockAnalysis codeWarnings do: [:eachString | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Error';
				title: 'Suspicious Code';
				description: eachString;
				solution: 'Make the Condition send messages only to the process. If it''s a forbidden field name then use #getValueOf: instead.';
				yourself.
			report add: reportItem.]].

	^report! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getTaskNamed: aString ifNone: aBlock

	^self getTaskNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getTaskNodes

	^activities select: [:each | each isTaskNode]! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
getTaskScriptWarnings
	""
	| report |

	report := OrderedCollection new.

	self getScriptNodes do: [:eachScrpt | | blockAnalysis | 
		blockAnalysis := BpmTaskScriptCodeAnalyzer new blockCode: eachScrpt script.
		blockAnalysis analyze.
		blockAnalysis codeWarnings do: [:eachString | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Error';
				title: 'Task Script Error';
				description: eachString;
				solution: 'The Script must be a block with two arguments: [:process :script | ]';
				yourself.
			report add: reportItem.]].

	^report! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 06/25/2016 13:27'!
getTransitionNamed: aString ifNone: aBlock

	^transitions detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
hasEndNodes

	^endNodes notEmpty! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/26/2016 13:31'!
hasParentProcess

	parentPool ifNotNil: [^parentPool hasParentProcess].

	parentWorkflow ifNotNil: [^true].

	^false! !

!XPDLWorkflowProcess methodsFor: 'import checks' stamp: 'BrunoBB 06/25/2016 13:27'!
hasStartNode

	^startNode notNil! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 13:28'!
initialize

	super initialize.

	activities := Dictionary new.
	lanes := Dictionary new.
	transitions := OrderedCollection new.
	endNodes := OrderedCollection new.
	embeddedSubprocesses := Dictionary new.! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 13:27'!
isEmbedded

	^parentWorkflow notNil! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:27'!
lanes
	^lanes! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:27'!
lanes: newValue
	lanes := newValue! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 13:27'!
package

	^parentPool package! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 06/26/2016 13:55'!
parentLanes

	parentWorkflow ifNotNil: [^parentWorkflow parentLanes].

	parentPool ifNil: [^#()].

	^parentPool lanes! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:27'!
parentPool
	^parentPool! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:27'!
parentPool: newValue
	parentPool := newValue! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:28'!
parentWorkflow
	^parentWorkflow! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:28'!
parentWorkflow: newValue
	parentWorkflow := newValue! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:27'!
processId
	^processId! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:27'!
processId: newValue
	processId := newValue! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 06/25/2016 13:27'!
setStartAndEndNodes
	"The receiver connect with The XPDL Start node and with All XPDL End node"

	startNode := activities detect: [:each | each isStartNode] ifNone: [nil]. "only one"

	endNodes := activities select: [:each | each isEndNode]. "can be more than one"! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:27'!
startNode
	^startNode! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:27'!
startNode: newValue
	startNode := newValue! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 06/25/2016 13:27'!
transitions
	^transitions! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 06/25/2016 13:27'!
transitions: newValue
	transitions := newValue! !

Object subclass: #XPDLReader2
	instanceVariableNames: 'xpdlDocuments xpdlPackages importReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLReader2 subclass: #BizagiXPDLReader2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

BizagiXPDLReader2 subclass: #BizagiXPDLReader29
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

BizagiXPDLReader2 subclass: #BizagiXPDLReader30
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 03/21/2016 06:07'!
exampleMultipleProcesses

		^(XPDLReader2 for: 'TestCase' withString: XPDLProcessDefinitionTemplate xpdlExample_ProcessTestCase)
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessDefinitionTemplate xpdlExample_ProcessFixIssue) namedAs: 'FixIssue';
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessDefinitionTemplate xpdlExample_ProcessReportToArchitect) namedAs: 'ReportToArchitect';
				connectProcesses;
				yourself! !

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 03/21/2016 06:07'!
exampleMultipleProcesses2

		^(XPDLReader2 for: 'TestCase' withString: XPDLProcessDefinitionTemplate xpdlExample_ProcessTestCase2)
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessDefinitionTemplate xpdlExample_ProcessFixIssue) namedAs: 'FixIssue';
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessDefinitionTemplate xpdlExample_ProcessReportToArchitect) namedAs: 'ReportToArchitect';
				connectProcesses;
				yourself! !

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 03/21/2016 06:07'!
exampleMultipleProcesses3

		^(XPDLReader2 for: 'TestCase' withString: XPDLProcessDefinitionTemplate xpdlExample_ProcessTestCase3)
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessDefinitionTemplate xpdlExample_ProcessFixIssue) namedAs: 'FixIssue';
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessDefinitionTemplate xpdlExample_ProcessReportToArchitect) namedAs: 'ReportToArchitect';
				connectProcesses;
				yourself! !

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
for: processName withString: xmlString 

	^super new initialize
		addXPDLDocument: (XMLDOMParser parse: xmlString) namedAs: processName;
		yourself! !

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
forFiles: pathFileCollection
	| reader file contents |

	pathFileCollection isEmpty ifTrue: [^super new initialize].

	file:= FileStream fileNamed: pathFileCollection first.
	contents := file contents.
	file close.
	reader := self for: pathFileCollection first withString: contents.

	pathFileCollection allButFirst do:[:each |
		file:= FileStream fileNamed: each.
		contents := file contents.
		file close.
		reader addXPDLDocument: (XMLDOMParser parse: contents) namedAs: each].

	^reader connectProcesses! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
addXPDLDocument: xpdlDocument namedAs: xpdlName
	"The receiver add a collection of processes contained in <xpdlDocument> "
	| newPackage |

	xpdlDocuments at: xpdlName put: xpdlDocument.
	newPackage := XPDLPackageNode newOn: self.
	newPackage name: (self getPackageNameFrom: xpdlDocument);
		xmlSegment: (self getPackageFrom: xpdlDocument);
		createParticipants;
		createXpdlComponents.

	xpdlPackages at: newPackage getName put: newPackage.! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
connectProcesses

	self connectSubProcesses. "connect each <XPDLSubProcess> node with it's process definition <XPDLPoolNode>"! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
connectSubProcesses
	"The receiver connect each <XPDLSubProcess> node with it's process definition <XPDLPoolNode>"

	self getAllSubProcessNodes do: [:subProcNode | 
		subProcNode subProcess: (self getAllPools detect: [:each | each workflowId = subProcNode subProcessId] ifNone: [nil])]! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
getAllPools
	"Answer a collection with all sub process nodes of all pools"
	| allPools |

	allPools := OrderedCollection new.

	xpdlPackages do: [:each | allPools addAll: each pools].

	^allPools! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
getAllSubProcessNodes
	"Answer a collection with all sub process nodes of all pools"
	| subProcessNodes |

	subProcessNodes := OrderedCollection new.

	xpdlPackages do: [:each | subProcessNodes addAll: each getAllSubProcessNodes].

	^subProcessNodes! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:08'!
getAllWorkflows
	"Answer a collection with all worflows all packages"

	^self getAllPools collect: [:each | each workflow]! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 08/02/2016 13:58'!
getImportWarningReport

	importReport addAll: self getSubProcessNodesWithoutProcessDefinition.

	self getAllWorkflows do: [:each | 
		importReport addAll: each getActivitiesWithMixedStartConditions; "activities with some conditions in one transition and none in others"
			addAll: each getActivitiesWithoutName; "activities without name"
			addAll: each getActivitiesWithSameName; "activities with the same name"
			addAll: each getEndNodesReport; "has no end nodes"
			addAll: each getGatewaysWithoutConditions; "gateways without conditions"
			addAll: each getIsolatedActivities; "activities without any connection"
			addAll: each getLanesWithoutName; "lanes without name"
			addAll: each getStartNodeReport; "has no start node"
			addAll: each getSuspiciousConditions;
			addAll: each getTaskScriptWarnings.
	].

	^importReport! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 03/21/2016 15:46'!
getImportWarningReportWith: mapperDictionary
	"The receiver generates the import report of the XPDL files.
	1- Do basic checks to the process definition.
	2- Perform checks that require anOrbeon Application, the mapping is done using the mapper <mapperDictionary>"

	importReport := self getImportWarningReport.

	self getAllWorkflows do: [:each | | app |
		app := mapperDictionary at: each getName ifAbsent: [nil].
		app ifNotNil: [
			each appendFormsWithMissingMandatoryFieldsIn: app to: importReport;
				appendNonExistingFormsReportFor: app to: importReport;
				appendNonExistingRolesReportFor: app to: importReport.
		].
	].! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
getPackageFrom: xpdlDocument

	^xpdlDocument findElementNamed: 'Package'! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
getPackageNamed: aString

	^xpdlPackages at: aString ifAbsent: [nil]! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
getPackageNameFrom: xpdlDocument

	^(xpdlDocument findElementNamed: 'Package')
			ifNil: [nil]
			ifNotNil: [:node | node attributeAt: 'Name']! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:52'!
getSubProcessNodesWithoutProcessDefinition
	"Answer a collection of <XPDLSubProcessActivity> where it's Process Definition is NOT defined in <allProcesses>.
	This will cause an error because some subprocesses are NOT defined"
	| allPackagesNames report |

	report := OrderedCollection new.
	allPackagesNames := xpdlPackages collect: [:each | each getName].

	xpdlPackages do: [:eachPack | 
		(eachPack getAllSubProcessNodes reject: [:eachAct | allPackagesNames includes: eachAct getName]) do: [:eachAct | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Error';
				title: 'Sub Process Activity without Process Definition';
				description: 'Sub Process Activity [', eachAct getName, '] in Process  [', eachPack getName, '] has NO Process Definition';
				solution: 'Define in Bizagi a SubProcess with the same Sheet name as the SubProcess node (in the parent Process definition)';
				yourself.
			report add: reportItem.
			]
	].
	^report! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 12:19'!
hasParentProcess: aXPDLPackageNode
	"Answer whether or not the xpdl package <aXPDLPackageNode> has parent process"

	^xpdlPackages anySatisfy: [:package | 
		package getAllSubProcessNodes anySatisfy: [:xpdlSubProcessNode |
			xpdlSubProcessNode getName = aXPDLPackageNode getName.
		].
	]! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/22/2016 11:33'!
hasWarnings

	^importReport notEmpty! !

!XPDLReader2 methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 12:20'!
importReport
	^importReport! !

!XPDLReader2 methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 12:20'!
importReport: newValue
	importReport := newValue! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 01/22/2016 11:28'!
initialize

	super initialize.

	xpdlDocuments := Dictionary new.

	xpdlPackages := Dictionary new.

	importReport := OrderedCollection new.! !

!XPDLReader2 methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 12:19'!
xpdlDocuments
	^xpdlDocuments! !

!XPDLReader2 methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 12:19'!
xpdlDocuments: newValue
	xpdlDocuments := newValue! !

!XPDLReader2 methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 12:19'!
xpdlPackages
	^xpdlPackages! !

!XPDLReader2 methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 12:19'!
xpdlPackages: newValue
	xpdlPackages := newValue! !
